/*
 * button_b.cpp
 *
 */

#include "button_b.h"

#include "../graphic/gra_lib.h"

namespace Api {

BitmapButton::BitmapButton(Torbit& gr, const Cutbit& c, int x, int y)
:
    Button (gr, x, y, c.get_xl(), c.get_yl()),
    cutbit (&c),
    x_frame(0)
{
}

BitmapButton::~BitmapButton()
{
}



void BitmapButton::draw_self()
{
    int y_frame = get_on() && !get_down() ? 1 : 0; // Button::draw setzt down
    Button::draw_self();
    cutbit->draw(get_ground(), get_x(), get_y(), x_frame, y_frame);
}



Checkbox::Checkbox(Torbit& ground, const int x, const int y)
:
    BitmapButton(ground,
     GraLib::get(Globals::file_bitmap_checkbox), x, y)
{
}

Checkbox::~Checkbox()
{
}

void Checkbox::set_checked(const bool b)
{
    set_x_frame(b);
    set_draw_required();
}

void Checkbox::toggle()
{
    set_x_frame(1 - get_x_frame());
    set_draw_required();
}

bool Checkbox::clicked(const int x, const int y)
{
    const bool b = Button::clicked(x, y);
    if (b) toggle();
    return b;
}

}
// Ende Namespace Api
