/*
 * api/button_e.cpp
 *
 */

#include "button_e.h"

namespace Api {

EnumButton::EnumButton(Torbit& b, int nx, int ny, int nxl, int nyl)
:
    TextButton(b, nx, ny, nxl, nyl),
    number    (0)
{
}


EnumButton::~EnumButton()
{
}



void EnumButton::set_number(const int i)
{
    if (!text_vector.empty()) {
        number = i % text_vector.size();
        set_text(text_vector[number]);
    }
    else number = 0;
}



void EnumButton::add_text(const std::string& s)
{
    // Ersten Eintrag sofort anzeigen, falls Zahl nicht geregelt wird
    if (text_vector.empty()) set_text(s);
    text_vector.push_back(s);
}



bool EnumButton::clicked(const int x, const int y)
{
    if (TextButton::clicked(x, y)) {
        set_number(number + 1);
        return true;
    }
    else return false;
}

}
// Ende Namensraum
