/*
 * api/button_k.cpp
 *
 */

#include "button_k.h"

#include "../other/language.h"

namespace Api {

KeyButton* KeyButton::selection(0);



KeyButton::KeyButton(Torbit& b, int x, int y, int xl, int yl, int sc)
:
    TextButton(b, x, y, xl, yl),
    scancode  (sc)
{
    set_scancode(sc);
}



KeyButton::~KeyButton()
{
    if (selection == this) selection = 0;
}



void KeyButton::set_scancode(const int sc)
{
    if (sc > 0 && sc < KEY_MAX) {
        scancode = sc;
        set_text(scancode_to_name(scancode));
    }
    else {
        scancode = 0;
        set_text(Language::option_key_unassigned);
    }
}



// This is some code that's copied and greatly simplified from TextType.
void KeyButton::calculate(const int x, const int y)
{
    if (!get_on()) {
        if (clicked(x, y)) set_on();
    }
    // Schreibmodus
    else {
        if (selection != this) {
            if (selection) selection->set_off();
            selection = this;
        }
        // cancel
        if (hardware.key_once(KEY_ESC)
         || hardware.get_mr() || hardware.get_ml()) {
            selection = 0;
            set_off();
        }
        // Oder doch noch im Schreibmodus bleiben? Dann Tastatur lesen.
        else {
            int k = hardware.get_key();
            if (k >= 0 && k < KEY_MAX) {
                set_scancode(k);
                selection = 0;
                set_off();
            }
        }
        set_draw_required(); // to get the blinking "?" whenever necessary
    }
}



void KeyButton::draw_self()
{
    if (get_on() && Help::timer_ticks % 30 < 15) set_text("?");
    else set_scancode(scancode); // regular text, i.e. the key name

    TextButton::draw_self();
}

}
// end of namespace
