/*
 * api/button_k.h
 *
 * A button used in the keybinding menu. Click on it and press a key to
 * assign the button  a scancode.
 *
 */

#pragma once

#include "button_t.h"

namespace Api {

class KeyButton : public TextButton {

private:

    static KeyButton* selection;

    int  scancode;

public:

    //        wohin           x        y        x_len      y_len     scancode
    KeyButton(Torbit& = *osd, int = 0, int = 0, int = 100, int = 20, int = 0);
    virtual ~KeyButton();

    inline static KeyButton* get_selection() { return selection; }

    inline  int  get_scancode() const { return scancode; }
            void set_scancode(int);

    virtual void calculate(int x, int y);
    virtual void draw_self();

}; // end of class
}  // end of namespace
