/*
 * ./api/button_s.h
 *
 * Ein 60 x 40 Pixel grosser Button mit einer Lemming-Faehigkeit als Bild und
 * einer grossen Zahl oben.
 *
 * Ist die Zahl >= 100, gilt die Faehigkeit als unbegrenzt oft nutzbar.
 *
 */

#pragma once

#include "button.h"

#include "../graphic/graphic.h"
#include "../lemming/lem_enum.h"

namespace Api {
class SkillButton : public Button {

private:

    unsigned    number;
    Lem::Ac skill;

    Graphic lem;

public:

    //                   Grund,   x,                  y
             SkillButton(Torbit&, const unsigned = 0, const unsigned = 0,
                         const Lem::Ac = Lem::NOTHING,
                         const int = 0, const Lem::Style = Lem::GARDEN);
    virtual ~SkillButton();

    virtual void       set_x(const int);
    virtual void       set_y(const int);

    inline Lem::Ac get_skill()    const { return skill;              }
    inline unsigned    get_number()   const { return number;             }

           void        set_skill(const Lem::Ac a);
           void        set_number(const unsigned);

protected:

    virtual void draw_self();

}; // Ende Klasse
}  // Ende Namensraum
