/*
 * api/message.cpp
 *
 */

#include "message.h"

namespace Api {

BoxMessage::BoxMessage(const unsigned int xl,
                       const unsigned int lines, const std::string& s)
:
    //     Wo?  X-Koordinate,      Y-Koordinate,
    Window(*osd, LEMSCR_X/2 - xl/2, LEMSCR_Y/2 - 50 - lines*10,
    //           X-Laenge,          Y-Laenge,       Fenstertitel
                 xl,                100 + lines*20, s)
{
}

BoxMessage::~BoxMessage()
{
    text.clear();
    button.clear();
}





void BoxMessage::add_text(const std::string& t)
{
    text.push_back(t);
}

void BoxMessage::add_button(const std::string& t, const unsigned int hotkey)
{
    for (unsigned int i = 0; i < button.size(); ++i) {
        button[i].set_x(button[i].get_x() - 60);
    }
    TextButton but(get_torbit(),
     get_xl()/2 + button.size()*60 - 50,
     get_yl() - 40,
     100, 20);
    but.set_text(t);
    but.set_hotkey(hotkey);
    button.push_back(but);
}







void BoxMessage::calculate()
{
    button_number_clicked = 0;
    for (unsigned int i = 0; i < button.size(); ++i) {
        if (button_clicked(button[i])) button_number_clicked = i + 1;
    }
}

void BoxMessage::draw_self()
{
    for (unsigned int i = 0; i < text.size(); ++i) {
        draw_text(text[i], 20, 40 + i*20);
    }
    for (unsigned int i = 0; i < button.size(); ++i) {
        button[i].draw();
    }
}

} // Ende Namensraum Api
