/*
 * api/number.h
 *
 * Feld mit einer Ganzzahl und Buttons, welche die Zahl aendern koennen.
 *
 */

#pragma once

#include "element.h"
#include "frame.h"
#include "button_b.h"

namespace Api {
class Number : public Element {

private:

    const unsigned digits;
    const bool     six_buttons;

    int      number;

    int      minimum;
    int      maximum;
    unsigned step_sml;
    unsigned step_med;
    unsigned step_big;
    bool     white_zero;
    bool     format_time;

    BitmapButton down_big;
    BitmapButton down_med;
    BitmapButton down_sml;
    BitmapButton   up_sml;
    BitmapButton   up_med;
    BitmapButton   up_big;

public:

    //     Grund,   x,   y,    X-Laenge, Ziffern, Minimum, Maximum, Anfangsw.
    Number(Torbit&, int, int,  const unsigned = 110, const unsigned = 2,
                               const int = 0, const int = 99,  const int = 0,
                               const bool = false); // bool: Sechs Buttons
    virtual ~Number();

           void set_minimum (const int);
           void set_maximum (const int);
    inline int  get_minimum ()                 { return minimum;  }
    inline int  get_maximum ()                 { return maximum;  }
    inline void set_step_sml(const unsigned i) { step_sml = i;    }
    inline void set_step_med(const unsigned i) { step_med = i;    }
    inline void set_step_big(const unsigned i) { step_big = i;    }

    inline int  get_number()                   { return number;   }
    inline      operator int()                 { return number;   }
           void set_number(const int);
    inline void set_white_zero (bool b = true) { white_zero  = b; }
    inline void set_format_time(bool b = true) { format_time = b; }

    void calculate(int = 0, int = 0); // Offset fuer die Buttons

protected:

    virtual void undraw_self();
    virtual void draw_self();

}; // Ende der Klasse Number
}  // Ende Namensraum Api
