/*
 * varwin.h
 *
 * Dies ist ein editorinternes Fenster zum Einstellen der Levelvariablen,
 * etwa Name und Anzahl der Lemminge. Faehigkeiten werden in einem separaten
 * Fenster konfiguriert!
 *
 */

#pragma once

#include "../api/window.h"
#include "../level/level.h"

namespace Api {
class WindowVariables : public Window {

private:

    static const int this_xl;
    static const int this_yl;

    Level*     level; // Wird als Referenz dem Konstruktor uebergeben

    Texttype   author;
    Texttype   name_german;
    Texttype   name_english;

    Number     lemmings;
    Number     required;
    Number     rate;
    Number     seconds;

    TextButton ok;
    TextButton cancel;

    // Kopieren verboten
    WindowVariables(const WindowVariables&);
    void operator = (const WindowVariables&);

public:

             WindowVariables(Level&);
    virtual ~WindowVariables();

    void calculate();

protected:

    virtual void draw_self();

}; // Ende class WindowVariables
}  // Ende Namensraum
