/*
 * gameplay/player.cpp
 *
 */

#include "tribe.h"

Tribe::Tribe()
:
    lemmings_hatch(0),
    lemmings_saved(0),
    rate_min      (1),
    rate          (1),
    nuke          (false),
    update_hatch  (0),
    hatch_next    (0),
    skills_used   (0),
    style         (Lem::GARDEN)
{
}



Tribe::~Tribe()
{
    lemming.clear();
}



void Tribe::return_skills(const Lem::Ac ac, const int amount)
{
    size_t i;
    for (i = 0; i < Globals::skill_max; ++i)
     if (skill[i].ac == ac) {
        skill[i].nr += amount;
        skills_used -= amount;
        break;
    }
}



std::string Tribe::get_name() const
{
    std::string ret;
    for (std::list <Master> ::const_iterator
     itr = masters.begin(); itr != masters.end(); ++itr) {
        ret += itr->name;
        if (itr != --masters.end()) ret += ", ";
    }
    return ret;
}



int Tribe::get_lemmings_out() const
{
    int out = 0;
    for (std::vector <Lemming> ::const_iterator itr = lemming.begin();
     itr != lemming.end(); ++itr) if (itr->get_ac() != Lem::NOTHING) ++out;
    return out;
}
