/*
 * lemming/faller.cpp
 *
 * special_x
 *
 *   Zaehlt, wie viele Pixel der Lemming bereits nach unten gefallen ist.
 *   Wird ein Lemming zum Faller, so sollten die anderen Faehigkeiten, wenn
 *   sie diese Aktivitaet zuweisen, schon einige Pixel vorgeben mit
 *   set_special_x(), falls sie den Lemming bereits etwas bewegt haben.
 *
 *   Der Faller nutzt die Standardzuweisung assign_default(), damit beginnt
 *   er ansonsten bei null gefallenen Pixeln.
 *
 */

#include "ac.h"

void update_faller(Lemming& l, const UpdateArgs& ua)
{
    for (int i = 0; i < 7 && l.get_ac() == Lem::FALLER; ++i) {
        if (l.is_solid(0, i+2)) {
            l.move_down(i);
            // Gefallene Distanz erhoehen
            l.set_special_x(l.get_special_x() + i);
            // Schirm in letzter Sekunde?
            if (l.get_special_x() > Lemming::distance_safe_fall
             && !l.get_floater()) {
                l.assign(Lem::SPLATTER);
                l.play_sound(ua, Sound::SPLAT);
                // Nicht explodieren lassen, das tte er bei 76 :-)
                if (l.get_updates_since_bomb() == 75)
                 l.set_updates_since_bomb(0);
            } else if (l.get_special_x() > 9) {
                l.assign(Lem::LANDER);
            } else {
                l.assign(Lem::WALKER);
                // Das letzte Walker-Frame passt am besten
                l.set_frame(8);
            }
        }
    }

    if (l.get_ac() == Lem::FALLER) {
        l.set_special_x(l.get_special_x() + 6);
        l.move_down(6);
        l.next_frame();

        if (l.get_floater()
         && l.get_special_x() >= Lemming::distance_float) {
            l.assign(Lem::FLOATER);
        }
    }
}
