/*
 * lemming/init.cpp
 *
 * Initialisierungs-Unterklasse
 *
 */

#include "lemming.h"
#include "ac_func.h"

#include "../graphic/gra_lib.h"

std::vector <Lemming::AcFunc>      Lemming::ac_func(Lem::AC_MAX);

void Lemming::initialize_this_gets_called_from_glob_gfx_cpp()
{
    ac_func     [Lem::EXITER]    .assign = assign_exiter;
    ac_func     [Lem::WALKER]    .assign = assign_walker;
    ac_func     [Lem::CLIMBER]   .assign = assign_climber;
    ac_func     [Lem::BUILDER]   .assign = assign_builder;
    ac_func     [Lem::PLATFORMER].assign = assign_platformer;
    ac_func     [Lem::BASHER]    .assign = assign_basher;
    ac_func     [Lem::MINER]     .assign = assign_miner;
    ac_func     [Lem::DIGGER]    .assign = assign_digger;
    ac_func     [Lem::JUMPER]    .assign = assign_jumper;

    ac_func     [Lem::FALLER]    .update = update_faller;
    ac_func     [Lem::TUMBLER]   .update = update_tumbler;
    ac_func     [Lem::STUNNER]   .update = update_stunner;
    ac_func     [Lem::LANDER]    .update = update_lander;
    ac_func     [Lem::SPLATTER]  .update = update_splatter;
    ac_func     [Lem::BURNER]    .update = update_burner;
    ac_func     [Lem::DROWNER]   .update = update_drowner;
    ac_func     [Lem::EXITER]    .update = update_exiter;
    ac_func     [Lem::WALKER]    .update = update_walker;
    ac_func     [Lem::CLIMBER]   .update = update_climber;
    ac_func     [Lem::ASCENDER]  .update = update_ascender;
    ac_func     [Lem::FLOATER]   .update = update_floater;
    ac_func     [Lem::EXPLODER]  .update = update_exploder;
    ac_func     [Lem::BLOCKER]   .update = update_blocker;
    ac_func     [Lem::BUILDER]   .update = update_builder;
    ac_func     [Lem::SHRUGGER]  .update = update_shrugger;
    ac_func     [Lem::PLATFORMER].update = update_platformer;
    ac_func     [Lem::SHRUGGER2] .update = update_shrugger2;
    ac_func     [Lem::BASHER]    .update = update_basher;
    ac_func     [Lem::MINER]     .update = update_miner;
    ac_func     [Lem::DIGGER]    .update = update_digger;
    ac_func     [Lem::JUMPER]    .update = update_jumper;
    ac_func     [Lem::ROPER]     .update = update_roper;

    ac_func     [Lem::FALLER]    .pass_top =
    ac_func     [Lem::TUMBLER]   .pass_top =
    // ac_func     [Lem::JUMPER]    .pass_top =
    ac_func     [Lem::FLOATER]   .pass_top = true;

    ac_func     [Lem::NOTHING]   .nukable =
    ac_func     [Lem::SPLATTER]  .nukable =
    ac_func     [Lem::DROWNER]   .nukable =
    ac_func     [Lem::EXITER]    .nukable =
    ac_func     [Lem::EXPLODER]  .nukable = false;

    ac_func     [Lem::BUILDER]   .returns_x =
    ac_func     [Lem::PLATFORMER].returns_x = 12;

    ac_func     [Lem::ROPER]     .aiming    = true;
    ac_func     [Lem::ROPER]     .aim_sound = Sound::ROPER;
}
