/*
 * lemming/lem_enum.h
 *
 * This outsources all Lemming enums that were previously in lemming/lemming.h.
 * The idea is to not have almost everything depend on that file.
 *
 */

#pragma once

#include <string>

namespace Lem {

    const unsigned infinity = 100; // Fuer SkillButtons

    enum Ac {
        NOTHING,
        FALLER,
        TUMBLER,
        STUNNER,
        LANDER,
        SPLATTER,
        BURNER,
        DROWNER,
        EXITER,
        WALKER,

        CLIMBER,
        ASCENDER,
        FLOATER,
        EXPLODER,
        EXPLODER2,
        BLOCKER,
        BUILDER,
        SHRUGGER,
        PLATFORMER,
        SHRUGGER2,
        BASHER,
        MINER,
        DIGGER,

        JUMPER,
        ROPER,

        AC_MAX
    };

    enum Style {
        GARDEN,
        RED,
        YELLOW,
        GREEN,
        BLUE,
        CYAN,
        PURPLE,
        GREY,
        BLACK,
        STYLE_MAX
    };

    enum BodyPart {
        BODY,
        HAIR,
        RUCK,
        SKIN,
        BODY_PART_MAX
    };

    void initialize_strings_this_gets_called_from_globals_load_config_file();
    void initialize_colors_this_gets_called_from_glob_gfx_cpp();

          Ac           string_to_ac   (const std::string&);
          Style        string_to_style(const std::string&);
    const std::string& ac_to_string   (const Ac);
    const std::string& style_to_string(const Style);

          int          get_color      (const Style, const BodyPart);

}
// end of namespace
