/*
 * menu/browser.h
 *
 * Dies enthaelt die erweiterten LevelBrowser-Klassen, naemlich den Browser
 * fuer den Einzelspielermodus sowie den Levelauswaehler im Netzwerk.
 *
 * Ferner ist hier der ReplayBrowser definiert, auch wenn seine Funktionen
 * nicht in der brow_sin.cpp, sondern in der brow_rep.cpp definiert sind.
 *
 */

#pragma once

#include "brow_big.h"

#include "../api/brow_sav.h"

namespace Api {
class SingleBrowser : public BrowserBig {

private:

    TextButton button_edit;

    SingleBrowser   (const SingleBrowser&);
    void operator = (const SingleBrowser&);

    virtual void on_file_highlight(const std::string&);
    virtual void on_file_select(   const std::string&);

public:

             SingleBrowser();
    virtual ~SingleBrowser();

    virtual void calculate();

protected:

    virtual void draw_self();

};
// Ende Klasse SingleBrowser



class NetworkBrowser : public BrowserBig {
private:
    NetworkBrowser  (const NetworkBrowser&);
    void operator = (const NetworkBrowser&);
    virtual void on_file_highlight(const std::string&);
    virtual void on_file_select(   const std::string&);
public:
             NetworkBrowser();
    virtual ~NetworkBrowser();
    virtual void calculate();
};
// Ende Klasse NetworkBrowser



class ReplayBrowser : public BrowserBig {

private:

    bool            extraction_possible;
    bool            deletion_possible;
    TextButton      button_extract;
    TextButton      button_delete;

    SaveBrowser*    browser_save;
    BoxMessage*     box_delete;

    ReplayBrowser   (const ReplayBrowser&);
    void operator = (const ReplayBrowser&);
    virtual void on_file_highlight(const std::string&);
    virtual void on_file_select(   const std::string&);

public:

             ReplayBrowser();
    virtual ~ReplayBrowser();
    virtual void calculate();

    virtual void draw();     // Wichtig wegen des Unterfensters

protected:

    virtual void draw_self();

};
// Ende Klasse NetworkBrowser

}
// Ende Namensraum Api
