/*
 * menu/little.cpp
 *
 */

#include "little.h"

namespace Api {

NewPlayerMenu::NewPlayerMenu()
:
    Window(*osd, 190, 170, 260, 140,
                 Language::option_new_player_title),
    exit  (false),
    name  (get_torbit(),  60, 100, 140)
{
    name.set_on();

    // Begruessung und Aufforderung schreiben
    Help::draw_shadow_centered_text(get_torbit(), font_med,
     Language::option_new_player_first.c_str(),   get_xl() / 2, 40);
    Help::draw_shadow_centered_text(get_torbit(), font_med,
     Language::option_new_player_second.c_str(),  get_xl() / 2, 60);

    // Dies verhindert den pinken Hintergrund. Wir muessen dies tun, denn
    // wir waren bisher noch nicht im Hauptmenue.
    osd->clear_to_color(color[COL_BLACK]);
}



NewPlayerMenu::~NewPlayerMenu()
{
}



void NewPlayerMenu::calculate()
{
    // Die Koordinaten brauchen wir hier eigentlich nicht zu uebergeben,
    // weil wir das Namensfeld ja nicht anklicken wollen.
    name.calculate(get_x(), get_y());

    // Wir haben absichtlich keine Maus, also niemals aufhoeren zu schreiben!
    // Auf diese Weise erscheint der Button nicht einmal down, also derzeitig
    // angeklickt, wenn die unsichtbare Maus ihn anklickt.
    name.set_on();

    // Normalerweise rechnet man nicht weiter, wenn ein Texteingabefeld gerade
    // aktiv ist, aber in diesem Fall ist es sogar erwuenscht, dass mit dem
    // Enter-Druecken sofort der Dialog akzeptiert wird.
    // Ob der Name zu lang ist, prueft User::get_name().
    if (hardware.key_enter_once() && !name.get_text().empty()) {
        Globals::user.load(name.get_text());
        Globals::save_config_file();
        exit = true;
    }
}

void NewPlayerMenu::draw_self()
{
    name.draw();
}



// ############################################################################
// ############################################################################
// ############################################################################



LanguageMenu::LanguageMenu()
:
    Window(*osd, 250, LEMSCR_Y/2 - 15 * (Language::MAX + 1) +  5,
                 140,              30 * (Language::MAX + 1) - 10,
                 Language::lemmings_plus_plus),
    exit  (false)
{
    for (unsigned i = 0; i < Language::MAX; ++i)
     button.push_back(TextButton(get_torbit(), 20, 10 + 30 * i, 100, 20,
                                 Language::language_name[i]));

    // Dies verhindert den pinken Hintergrund. Wir muessen dies tun, denn
    // wir waren bisher noch nicht im Hauptmenue.
    osd->clear_to_color(color[COL_BLACK]);
}



LanguageMenu::~LanguageMenu()
{
}



void LanguageMenu::calculate()
{
    std::vector <TextButton> ::iterator i = button.begin();
    for (++i; i != button.end(); ++i)
     if (button_clicked(*i)) {
        exit_with = static_cast <Language::Language> (i - button.begin());
        exit = true;
    }
}



void LanguageMenu::draw_self()
{
    std::vector <TextButton> ::iterator i = button.begin();
    for (++i; i != button.end(); ++i) i->draw();
}

} // Ende Namensraum Api
