/*
 * menu/little.h
 *
 * Einige kleine Menues: Die Namensabfrage und die Sprachwahl.
 *
 */

#pragma once

#include "../api/window.h"
#include "../other/language.h"

namespace Api {

class NewPlayerMenu : public Window {

private:

    bool        exit;
    Texttype    name;

    // Kopieren verboten
    NewPlayerMenu   (const NewPlayerMenu&);
    void operator = (const NewPlayerMenu&);

public:

                NewPlayerMenu();
    virtual    ~NewPlayerMenu();

    void        calculate();
    inline bool get_exit() { return exit; }

protected:

    void        draw_self();

};



class LanguageMenu : public Window {

private:

    bool                     exit;
    Language::Language       exit_with;

    std::vector <TextButton> button;

    // Kopieren verboten
    LanguageMenu    (const LanguageMenu&);
    void operator = (const LanguageMenu&);

public:

                LanguageMenu();
    virtual    ~LanguageMenu();

    void                            calculate();
    inline const bool               get_exit()      { return exit;      }
    inline const Language::Language get_exit_with() { return exit_with; }

protected:

    void        draw_self();

};

} // Ende Namensraum Api
